void setup() 
{
  background(255);
  size(550, 550);
  stroke(0);
  smooth();
  noLoop();
}

int order=-1, x0=25, y0=25, l=500;

void draw() 
  {
     background(255);
     stroke(0);
     quad(x0,y0,x0,y0+l,x0+l,y0+l,x0+l,y0);
     line(x0,y0,x0+l,y0+l);
     stroke(255,0,0);
     strokeWeight(2);
     drawStaircase(order,x0,y0,l);
     strokeWeight(1);
  }

void drawStaircase(int order, int x, int y, int l)
  {
    if (order == 0)
      drawCorner(x,y,l);  
    else
      if (order>0)
      {
        drawStaircase(order-1,x,y,l/2);
        drawStaircase(order-1,x+l/2,y+l/2,l/2);
      }
   }

void drawCorner(int x, int y, int l)
  {
    line(x,y,x,y+l);
    line(x,y+l,x+l,y+l);
  }
  
  void mousePressed() 
  {
    redraw();
    order++;
    if (order==10)
      order=-1;
  }
  
