void setup() 
{
  background(255);
  size(1400, 500);
  noStroke();
  smooth();
  fill(255,0,0);
  noLoop();
}

int order=0, x=25, y=200, h=100, l=1350;

void draw() 
  {
     background(255);
     drawCantor(order,x,y,h,l);
  }

void drawCantor(int order, int x, int y, int h, int l)
  {
    if (order == 0)
      drawStrip(x,y,h,l);  
    else
      {
        l=round(l/3.0);
        drawCantor(order-1,x,y,h,l);
        drawCantor(order-1,x+2*l,y,h,l);
      }
   }

void drawStrip(int x, int y, int h, int l)
  {
    quad(x,y,x,y+h,x+l,y+h,x+l,y);
    
  }
  
  void mousePressed() 
  {
    redraw();
    order++;
    if (order==8)
      order=0;
  }
  
